%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                             ʵʱϷģ                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Simulink.sdi.clear
clc, clear, close all

load_system ('vRTHS_Frame')

%% ģд
% prompt = 'ȷԵģ(Perturbed case)д [default20]: ';
prompt = 'How many additional cases (Perturbed case) you would like to run? [default:20]: ';
num_add = input(prompt);
if isempty(num_add)
    num_add = 20;
end
disp('-----------------------------------------------------------------------')

num_t = 1+num_add; 
for ii = 1:num_t
    if (ii==1)
        TEST{ii,1} = strcat('Nominal case');
        rd = 0;
        ploton = 1;
    else
        TEST{ii,1} = strcat('Perturbed_', num2str(ii-1), ' case');
        rd = 1;
        ploton = 0; % 1-Perturbed caseĽͼ 0-
    end
    
disp(['---------------------------' TEST(ii) '---------------------------'])
%% ṹģ
dt = 1/1000;

% Ground Motion
EQ_scale = 1;
load('ELC180');
t_total = ELC180(1,end);
t = 0:dt:t_total;


% Mass
m1 = 40000;
m2 = 40000;
M = diag([m1,m2]);

% Stiffness
Lcol = 3.6;
Es=2e+11;
Ix=199327500e-12;
k_col = 12*Es*Ix/power(Lcol,3);
K = [4*k_col, -2*k_col; -2*k_col, 2*k_col];
KN = [3*k_col, -2*k_col; -2*k_col, 2*k_col];
kE = 2*k_col;  % 3*Es*Ix/power(Lcol/2,3);

% Damping
dpksi1 = 0.03;
dpksi2 = 0.03;
IMK = inv(M)*K;
E = eig(IMK);
W = sqrt(E);
omega = sort(W);
omega1 = omega(1);
omega2 = omega(2);
alpha = 2*omega1*omega2*(dpksi2*omega1-dpksi1*omega2)/(omega1*omega1-omega2*omega2);
beita = 2*(dpksi1*omega1-dpksi2*omega2)/(omega1*omega1-omega2*omega2);
C = alpha*M+beita*K;
cE = 0;

% State space model
As =[ zeros(2)  eye(2);
      -M\KN     -M\C];
Bs =[ zeros(2,1)  zeros(2);
      -ones(2,1)  -inv(M)];
Cs =[ eye(2)    zeros(2)
      zeros(2)  eye(2);
      -M\KN     -M\C];
Ds =[ zeros(2,1)  zeros(2);
      zeros(2,1)  zeros(2);
      -ones(2,1)  -inv(M)];

%% 
p_noise_d = 1e-8;
p_noise_f = 100;

%% ݺ
Kp = 1.0042 + 4.1474e-5 * rd * randn(1,1);
Tw = 0.0038319 + 1.5492e-7 * rd * randn(1,1);
Zeta = 0.28797; + 5.6334e-5 * rd * randn(1,1);
Tp3 = 0.0098583 + 4.4952e-6 * rd * randn(1,1);
Tz = 0.005956 + 8.8255e-7 * rd * randn(1,1);
Td = 0.0043262; + 4.5976e-6 * rd * randn(1,1);
TA = [0 Tz 1];
TB = [Tw*Tw 2*Zeta*Tw 1];
TC = [Tp3 1];


%% SIMULINK
set_param(bdroot,'SolverType','Fixed-step','Solver','ode4','StopTime','t_total','FixedStep','dt')
sim ('vRTHS_Frame');


%% ƽԱͼ
Ref = load('..\Entire_Dynamic_Elastic\data_Reference\Displacement.txt');
t_R = Ref(:,1);
d_R = Ref(:,2:3);

if (ploton==1)
    scrsz = get(0,'ScreenSize');
    figure('Name','Virtual RTHS','Position',[20 20 scrsz(3)/2-20 scrsz(4)-40])
    for i=1:2
        sp(i)= subplot(2,1,i); grid on, hold on
        plot(t,Resp_N.Data(:,i),':','color','r','linewidth',1.5)
        plot(t_R,d_R(:,i),':','color','g','linewidth',1.5)
        set(sp(i),'fontsize',10)
        xlim([0,t_total])
        xlabel(sp(i),'Time (sec)','fontsize',12,'fontweight','bold');
        ylabel(sp(i),['Displacement - ' int2str(i) 'st Storey (m)'],'fontsize',12,'fontweight','bold');
    end
    l = legend(sp(2),{'vRTHS','Reference'},'fontsize',10,'location','north', 'Orientation','horizontal');
    set(l,'Position',[0.33 0.93 0.3816 0.05000]);

    figure('Name','Experimental displacement','Position', [scrsz(3)/2+20 20 scrsz(3)/2-20 scrsz(4)-40])
    plot(t,d_E.Data(:,1),':','color','r','linewidth',1.5)
    hold on
    plot(t,d_act.Data(:,1),':','color','g','linewidth',1.5)
    hold off
    xlim([0,t_total])
    xlabel('Time (sec)','fontsize',12,'fontweight','bold');
    ylabel('d_E (m)','fontsize',12,'fontweight','bold');
    l = legend({'Command disp','Realized Disp'},'fontsize',10,'location','north', 'Orientation','horizontal');
    set(l,'Position',[0.33 0.93 0.3816 0.05000]);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           һλƵRMSE                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
deltt = 0.005;
d_RTHS = resample(Resp_d1,[deltt:deltt:49.995],'linear');

d1_RTHS = d_RTHS.Data(:,1);
d1_R = d_R(:,1);

dd = d1_RTHS-d1_R;
RMSE = sqrt( (dd'*dd) / (d1_R'*d1_R) );

RMSE_ALL(ii,1) = RMSE;
end

Results = table( RMSE_ALL, 'Rownames', TEST )